#include "Leds.h"
#include "Lasers.h"

TIMEOUT timeoutLed;

///   BATTERY STATUS    ///

uint8_t BatteryStatus = 0;

///   LED PINS    ///

const uint8_t ledsPins[] = {4,2,15,27,33};

///   LED STATUS    ///

uint8_t ledStatus[5];

void initLeds(void)
{
  for(uint8_t i = 0; i<nbrLeds;i++)
  {
    pinMode(ledsPins[i], OUTPUT);
    LedOn(i);
    delay(500);
  }

  for(uint8_t j = 0; j<nbrLeds;j++)
  {
    LedOff(j);
  }

  timeoutLed.setTimeout(1000);
  timeoutLed.startTimeout();
}

void LedOn(uint8_t led_Id)
{
  digitalWrite(ledsPins[led_Id], HIGH);
  ledStatus[led_Id] = 1;
}

void LedOff(uint8_t led_Id)
{
  digitalWrite(ledsPins[led_Id], LOW);
  ledStatus[led_Id] = 0;
}

void LedToggle(uint8_t led_Id)
{
  if(ledStatus[led_Id] == 1)
    LedOff(led_Id);
  else
    LedOn(led_Id);
}

void tick_Leds(double measureBattery)
{
  if(measureBattery < 1.0)
    BatteryStatus = 1;
  else
    BatteryStatus = 0;
  if(BatteryStatus)
  {
    if(timeoutLed.checkTimeoutExpired())
    {
       timeoutLed.setTimeout(1000);
       timeoutLed.startTimeout();
       LedToggle(0);
    }
  }
}
