#include "Vibreur.h"

///   PIN VIBREUR   ///
#define pinVibreur  9

///   VIBRATION MODES   ///

const uint8_t vibrationModesValues[4] = {1,5,10,100};

enum VibrateModesNames
{
  impulsions = 0,
  saccade_lent,
  saccade_rapide,
  continu
};

uint8_t actualMode = 0;
uint8_t actualIntensity = 255;

void initVibreur(void)
{
  ledcSetup(0, 1, 8);
  ledcAttachPin(pinVibreur, 0);
  vibreurOn(2, 255);
  delay(1000);
  vibreurOff();
}

void vibreurOn(uint8_t Mode, uint8_t intensity)
{

  if(vibrationModesValues[Mode]>vibrationModesValues[actualMode])
  {
    for(uint8_t i = vibrationModesValues[actualMode]; i<vibrationModesValues[Mode]+1;i++)
      ledcWriteTone(0, i);
    actualMode = Mode;
  }
  if(vibrationModesValues[Mode]<vibrationModesValues[actualMode])
  {
    for(uint8_t i = vibrationModesValues[actualMode]; i>vibrationModesValues[Mode]-1;i--)
      ledcWriteTone(0, i);
    actualMode = Mode;
  }
  ledcWrite(0, 255);
}

void vibreurOff(void)
{
  ledcWrite(0, 0);
}

void tick_Vibreur(uint16_t* measures, double* eqPlan1, double* eqPlan2)
{
  
  if(eqPlan1[2]>-40 || eqPlan1[2]<-100 || eqPlan2[2]>-40 || eqPlan1[2]<-100)
  {
    if(measures[UpLaser]>1700)
      vibreurOn(3, 255);
    else if(measures[UpLaser]<1000)
      vibreurOn(0, 255);
    return;
  }
  
  vibreurOff();
}
