#include "VL53L1X.h"
#include "Communication.h"
#include "Lasers.h"
#include "Leds.h"
#include "Vibreur.h"
#include "ADC.h"
#include "Gyroscope.h"

uint16_t measures[nbrLasers] = {100};
double measureBattery;
float angles[3];
double eqPlan1[3];
double eqPlan2[3];

void setup() {
  // put your setup code here, to run once:

  initI2CBus();
  initSerialBus();
  scanI2C();
  init_Gyro();
  initLaserSensors();
  scanI2C();
  initLeds();
  initVibreur();
  
}

void loop() {
  // put your main code here, to run repeatedly:

  tick_Battery(&measureBattery);
  
  tick_Leds(measureBattery);

  tick_Lasers(measures, eqPlan1, eqPlan2);

  tick_Vibreur(measures, eqPlan1, eqPlan2);
  
  tick_Gyro(angles);
  
  Serial.print("Battery Voltage : ");Serial.println(measureBattery);
  Serial.print("AxeX : ");Serial.println(angles[axeX]);
  Serial.print("AxeY : ");Serial.println(angles[axeY]);
  Serial.print("AxeZ : ");Serial.println(angles[axeZ]);
}
