import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
import numpy as np

print("Please provide the 4 laser measurements in CENTIMETERS in the following order :")

BottomLasr = input("Bottom laser : ")
BottomLaser = float(BottomLasr)

LeftLasr = input("Left laser : ")
LeftLaser = float(LeftLasr)

RightLasr = input("Right laser : ")
RightLaser = float(RightLasr)

TopLasr = input("Top laser : ")
TopLaser = float(TopLasr)
130
# For the two side laser, the side is determind when holding the device normally
# X values are the measures of the 3 lower lasers, the order is : bottom laser, left laser and then right laser
# Y values represent the lateral distance of each laser relative to the center of the front plate
# Z values represent the vertical distance of each laser relative to the center of the front plate

xs = [BottomLaser, LeftLaser, RightLaser]
#xs = [120, 130,130]
ys = [0,-1.675,1.675]
zs = [-1.73,0,0]

# X1 values are the measures of the 3 upper lasers, the order is : left laser, right laser and then top laser
# Y1 values represent the lateral distance of each laser relative to the center of the front plate
# Z1 values represent the vertical distance of each laser relative to the center of the front plate

x1s = [LeftLaser, RightLaser, TopLaser]
#x1s = [130, 130,140]
y1s = [-1.675,1.675,0]
z1s = [0,0,1.93]

# plot raw data
plt.figure()
ax = plt.subplot(111, projection='3d')
ax.scatter(xs, ys, zs, color='b')
ax.scatter(x1s, y1s, z1s, color='r')

# Computation of the first plane's equation
tmp_A = []
tmp_b = []
for i in range(len(xs)):
    tmp_A.append([xs[i], ys[i], 1])
    tmp_b.append(zs[i])
b = np.matrix(tmp_b).T
A = np.matrix(tmp_A)
fit = (A.T * A).I * A.T * b
errors = b - A * fit
residual = np.linalg.norm(errors)

# Computation of the second plane's equation
for i in range(len(x1s)):
    tmp_A.append([x1s[i], y1s[i], 1])
    tmp_b.append(z1s[i])
b = np.matrix(tmp_b).T
A = np.matrix(tmp_A)
fit1 = (A.T * A).I * A.T * b
errors = b - A * fit1
residual = np.linalg.norm(errors)

print()
print("First plane (3 lower lasers) :")
print("%f x + %f y + %f = z" % (fit[0], fit[1], fit[2]))
print()
print("Second plane (3 upper lasers) :")
print("%f x + %f y + %f = z" % (fit1[0], fit1[1], fit1[2]))

# Plot of the two planes
# Red dots are upper lasers values
# Blue dors are lower lasers values

xlim = ax.get_xlim()
ylim = ax.get_ylim()
X,Y = np.meshgrid(np.arange(xlim[0], xlim[1]),
                  np.arange(ylim[0], ylim[1]))
Z = np.zeros(X.shape)
for r in range(X.shape[0]):
    for c in range(X.shape[1]):
        Z[r,c] = fit[0] * X[r,c] + fit[1] * Y[r,c] + fit[2]
ax.plot_wireframe(X,Y,Z, color='k')

X1,Y1 = np.meshgrid(np.arange(xlim[0], xlim[1]),
                  np.arange(ylim[0], ylim[1]))
Z1 = np.zeros(X1.shape)
for r in range(X1.shape[0]):
    for c in range(X1.shape[1]):
        Z1[r,c] = fit1[0] * X1[r,c] + fit1[1] * Y1[r,c] + fit1[2]
ax.plot_wireframe(X1,Y1,Z1, color='k')

ax.set_xlabel('x')
ax.set_ylabel('y')
ax.set_zlabel('z')
plt.show()